// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: testCopyColumn
// Author: Hassan Siddiqui
//
// Description: Test harness for CopyUtils class
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: testWCSConvertor.cc,v 1.1 2012/01/25 15:46:31 rsaxton Exp $




// General classes

#include <iostream>


// SAS-specific classes

#include "param.h"
#include "Dal.h"
#include "WCSConvertor.h"

// General utility functions
#include "Tracer.h"
 
// ---------------------------------------------------

// Main function

// ---------------------------------------------------

int main()
{
  PROC; 

  /************************
   *
   * Using values in section 6 of
   * 'Representation of celestial coordinates in FITS'
   *
   ************************/

  WCSConvertor wcs( "RA---TAN",
		    256,
		    45.83,
		    -0.00277777,
		    "DEC--TAN",
		    257,
		    63.57,
		    0.00277777);

  {
    double pixx = 0.5;
    double pixy = 0.5;

    CoordPair coords = wcs.physicalCoords(pixx + 0.5, pixy + 0.5); // physicalCoords already corrects to centre of pixel, need to compensate for this
    
    errstr 
      << "Given input pix coords of [" << pixx
      << " , " << pixy
      << " ] Got coord pair of [" << coords.x()
      << " , " << coords.y() << "]"
      << Sas::message(Msg::App, Msg::Verbose);
  }

  {
    double pixx = 512.5;
    double pixy = 512.5;

    CoordPair coords = wcs.physicalCoords(pixx + 0.5, pixy + 0.5);
    
    errstr 
      << "Given input pix coords of [" << pixx
      << " , " << pixy
      << " ] Got coord pair of [" << coords.x()
      << " , " << coords.y() << "]"
      << Sas::message(Msg::App, Msg::Verbose);
  }



//    WCSConvertor wcs( "RA---TAN",
//  		    25921,
//  		    20.9,
//  		    -1.38889e-05,
//  		    "DEC--TAN",
//  		    25921,
//  		    -58.7886,
//  		    1.38889e-05 );

//    {
//      double pixx = 24677;
//      double pixy = 24960;

//      CoordPair coords = wcs.physicalCoords(pixx, pixy);
    
//      errstr 
//        << "Given input pix coords of [" << pixx
//        << " , " << pixy
//        << " ] Got coord pair of [" << coords.x()
//        << " , " << coords.y() << "]"
//        << Sas::message(Msg::App, Msg::Verbose);
//    }

//    {
//      double pixx = 25921;
//      double pixy = 25921;

//      CoordPair coords = wcs.physicalCoords(pixx, pixy);
    
//      errstr 
//        << "Given input pix coords of [" << pixx
//        << " , " << pixy
//        << " ] Got coord pair of [" << coords.x()
//        << " , " << coords.y() << "]"
//        << Sas::message(Msg::App, Msg::Verbose);
//    }

//    RETURN 0;
} 
